VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1395
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   1395
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdTranslate 
      Caption         =   "Acknowledge"
      Height          =   495
      Left            =   2880
      TabIndex        =   0
      Top             =   240
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Sample program that acknowledges an EDI file using the Forward Only cursor type.
'This is recommended for acknowledging huge EDI files.

Private Sub cmdTranslate_Click()
    Dim oEdiDoc As Fredi.ediDocument
    Dim oSef As Fredi.ediSchema
    Dim oSegment As Fredi.ediDataSegment
    Dim oAck As Fredi.ediAcknowledgment
    Dim sSefFile As String
    Dim sSef997 As String
    Dim sEdiFile As String
    Dim sAckfile As String
    
    Me.MousePointer = vbHourglass
    
    sSefFile = App.Path & "\850_x12-4010.sef"
    sSef997 = App.Path & "\997_4010.sef"
    sEdiFile = App.Path & "\850OUTPUT.X12"
    sAckfile = App.Path & "\997_850.X12"
    
    Set oEdiDoc = New Fredi.ediDocument
    
    'Sets cursor type to ForwardOnly.
    'This stops FREDI from loading the complete EDI file into memory.
    oEdiDoc.CursorType = Cursor_ForwardOnly
    
    'Increase the buffer option so that accessing the
    'hard drive does not become a bottleneck.
    oEdiDoc.Property(Property_DocumentBufferIO) = 200
    
    'Load SEF files for 997 and 850
    oEdiDoc.LoadSchema sSefFile, 0
    oEdiDoc.LoadSchema sSef997, 0
    
    'Enable acknowledgement
    Set oAck = oEdiDoc.GetAcknowledgment
    oAck.EnableFunctionalAcknowledgment = True
    
    'Loads EDI file.
    'When Cursor Type is set to Forward Only, this command does not load the
    'complete EDI file.
    oEdiDoc.LoadEdi sEdiFile
    
    'Because the Forward Cursor Type does not load the complete EDI file
    'into memory, we have to iterate through each segment so that they
    'be analyzed.
    Set oSegment = oEdiDoc.FirstDataSegment
    Do While Not oSegment Is Nothing
        Set oSegment = oSegment.Next
    Loop
    
    'Save acknowledgment file.
    oAck.Save sAckfile
    
    Me.MousePointer = vbNormal
    cmdTranslate.Enabled = False
    
    MsgBox "Done"
    
End Sub

